* PACKAGE DEULER    !" P \infty  ʬ( Euler Scheme )
*
*"  [HIS] 96/03/14 (takepiro) 
*"        98/06/11 (takepiro) Ǥβٷ׻ѹ
***********************************************************************
      SUBROUTINE DEULER
     O             ( PSI3  , ZETA3 , T3  ,
     I               PSI2  , ZETA2 , T2  , 
     I               RAYL  , PRND  , QINT,
     C               DX    , DZ    , DT  ,
     W               AJAC2 , ALAP2         )
*
*"      << Euler scheme ˤ꼡ƥåפʪ̤׻ >>
*
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
*
* [OUTPUT]
      REAL PSI3  ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(STEP)
      REAL ZETA3 ( 0:NX+1 , 0:NZ+1 ) !" (STEP)
      REAL T3    ( 0:NX+1 , 0:NZ+1 ) !" (STEP)
*
* [INPUT]
      REAL PSI2  ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(1STEP)
      REAL ZETA2 ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
      REAL T2    ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
*
      REAL PRND                 !" ץȥ(ߡ)
      REAL RAYL                 !" 쥤꡼
      REAL QINT                 !" ǮΨ
*
      REAL DX                   !" X γʻֳ
      REAL DZ                   !" Z γʻֳ
      REAL DT                   !" ֳִ
*
* [WORK]
      REAL AJAC2 ( 0:NX+1 , 0:NZ+1 ) !"䥳ӥ
      REAL ALAP2 ( 0:NX+1 , 0:NZ+1 ) !"ץ饷
*
      LOGICAL OFIRST
      DATA    OFIRST  / .TRUE. /
*    
      SAVE  OFIRST 
*
      IF( OFIRST ) THEN
         OFIRST = .FALSE.
         CALL MSGDMP('M','DEULER',
     &               'EULER SCHEME TIME INTEGRATE : 98/06/11' )
         CALL MSGDMP('M','DEULER',
     &               '***** INFINITE PRNDTL NUMBER APPROX. *****' )
      ENDIF
*
*"        < 1. ΰβ٤η׻ >
*
      CALL DEULRT
     O       ( T3    , 
     I         PSI2  , T2  , 
     C         QINT  , 
     C         DX    , DZ    , DT  ,
     W         AJAC2 , ALAP2   )
*
*"        < 2. ΰα٤η׻ >
*
      CALL DTMP2Z               !"  ٤鱲٤η׻(P inf )
     O       ( ZETA3 , 
     I         T3    , 
     C         RAYL  , 
     C         DX    , DZ    , DT  ,
     W         ALAP2   )
*
*"        < 3. ŬѤήؿη׻ >
*
      CALL DBNDR
     O       ( PSI3 , 
     M         ZETA3, T3  ,
     I         DX   , DZ   )
*
      RETURN
      END
*****************************************************************
      SUBROUTINE DEULRT                !" Euler scheme ˤ벹
     O             ( T3    , 
     I               PSI2  , T2  , 
     C               QINT  , 
     C               DX    , DZ    , DT  ,
     W               AJAC2 , ALAP2   )
*
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
*
* [OUTPUT]
      REAL T3 ( 0:NX+1 , 0:NZ+1 ) !" (STEP)
*
* [INPUT]
      REAL PSI2 ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(1STEP)
      REAL T2   ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
*
      REAL QINT                      !" ǮΨ
      REAL DX                        !" X γʻֳ
      REAL DZ                        !" Z γʻֳ
      REAL DT                        !" ֳִ
*
* [WORK]
      REAL AJAC2 ( 0:NX+1,0:NZ+1 ) !" 䥳ӥ
      REAL ALAP2 ( 0:NX+1,0:NZ+1 ) !" ץ饷
*
*  [INTERNAL WORK]
      INTEGER IX                   !" 롼ץ
      INTEGER IZ                   !" 롼ץ
*
*"        < 1. ٤λѲη׻ >
*
      CALL DEULTT
     O         ( T3    , 
     I           PSI2  , T2  , 
     C           QINT  , 
     C           DX    , DZ  , 
     W           AJAC2 , ALAP2   )
*
*"        < 3. ƥåɤβ٤ͤη׻ >
*
      DO 3010 IZ = 0, NZ+1
         DO 3020 IX = 1 , NX
              T3(IX,IZ)
     &    =   T2(IX,IZ) + DT * T3( IX, IZ )
 3020    CONTINUE
 3010 CONTINUE
*
      RETURN
      END
*****************************************************************
      SUBROUTINE DEULTT        !" Euler scheme ˤ벹٤λѲ
     O             ( TNDT  , 
     I               PSI   , T    , 
     C               QINT  , 
     C               DX    , DZ   ,
     W               AJAC  , ALAP  )
*
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
*
* [OUTPUT]
      REAL TNDT  ( 0:NX+1 , 0:NZ+1 ) !" ٤λѲ
*
* [INPUT]
      REAL PSI   ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(1STEP)
      REAL T     ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
*
      REAL QINT                      !" ǮΨ
      REAL DX                        !" X γʻֳ
      REAL DZ                        !" Z γʻֳ
*
*  [WORK]
      REAL AJAC  ( 0:NX+1,0:NZ+1 )   !" 䥳ӥ
      REAL ALAP  ( 0:NX+1,0:NZ+1 )   !" ץ饷
*
*  [INTERNAL WORK]
      INTEGER IX                   !" 롼ץ
      INTEGER IZ                   !" 롼ץ
*
*"        < 1. 䥳ӥη׻ >
*
      CALL DARJAC
     O       ( AJAC ,
     I         PSI  , T   ,
     C         DX   , DZ   )
*
*"        < 2. ץ饷η׻ >
*
      CALL DLAPLA
     O       ( ALAP ,
     I         T    ,
     C         DX   , DZ   )
*
*"        < 3. Ǥη׻ (ǥեåͿ) >
*
      CALL DBNDRT
     O     ( TFB    , TFT   ,
     O       OTFIXB , OTFIXT  )
*
*"        < 3. ƥåɤβ٤ͤη׻ >
*
      IF ( .NOT. OTFIXB ) THEN
         DO 1010 IX = 1, NX
            ALAP( IX, 0 ) 
     &    = ( T(IX+1,0) - 2*T(IX,0) + T(IX-1,0) )/DX**2
     &      + (  ( T(IX,1)-T(IX,0) )/DZ - TFB(IX) )/DZ
 1010    CONTINUE
*
         DO 1020 IX = 1, NX
           TNDT(IX,0)
     &          =  AJAC(IX,0) + ALAP(IX,0) + 0.5 * QINT
 1020    CONTINUE
      ENDIF
*
      DO 2010 IZ = 1 , NZ
         DO 2020 IX = 1 , NX
           TNDT(IX,IZ)
     &          =  AJAC(IX,IZ) + ALAP(IX,IZ) + QINT 
 2020   CONTINUE
 2010 CONTINUE
*
      IF ( .NOT. OTFIXT ) THEN
         DO 3010 IX = 1, NX
            ALAP( IX, NZ+1 ) 
     &    = ( T(IX+1,NZ+1) - 2*T(IX,NZ+1) + T(IX-1,NZ+1) )/DX**2
     &      + ( TFT(IX) - ( T(IX,NZ+1)-T(IX,NZ) )/DZ  )/DZ
 3010    CONTINUE
*
         DO 3020 IX = 1, NX
           TNDT(IX,NZ+1)
     &          =  AJAC(IX,NZ+1) + ALAP(IX,NZ+1) + 0.5 * QINT 
 3020    CONTINUE
      ENDIF
*
      RETURN
      END
