* PACKAGE DLPFRG    !" P \infty  ʬ( Leap Frog Scheme )
*
*"  [HIS] 96/03/16 (takepiro) 
*"        98/06/11 (takepiro) Ǥβٷ׻ѹ
***********************************************************************
      SUBROUTINE DLPFRG
     O             ( PSI3  , ZETA3 , T3  ,
     I               PSI2  , ZETA2 , T2  , 
     I               PSI1  , ZETA1 , T1  , 
     I               RAYL  , PRND  , QINT,
     C               DX    , DZ    , DT  ,
     W               AJAC  , ALAP   ) 
*
*"    << Leapfrog scheme ˤ꼡ƥåפʪ̤׻ (P \infty ) >>
*
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
*
* [OUTPUT]
      REAL ZETA3 ( 0:NX+1 , 0:NZ+1 ) !" (STEP)
      REAL PSI3  ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(STEP)
      REAL T3    ( 0:NX+1 , 0:NZ+1 ) !" (STEP)
*
* [INPUT]
      REAL PSI2  ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(1STEP)
      REAL ZETA2 ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
      REAL T2    ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
      REAL PSI1  ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(2STEP)
      REAL ZETA1 ( 0:NX+1 , 0:NZ+1 ) !" (2STEP)
      REAL T1    ( 0:NX+1 , 0:NZ+1 ) !" (2STEP)
*
      REAL PRND                 !" ץȥ(ߡ)
      REAL RAYL                 !" 쥤꡼
      REAL QINT                 !" ǮΨ
*
      REAL DX                   !" X γʻֳ
      REAL DZ                   !" Z γʻֳ
      REAL DT                   !" ֳִ
*
* [WORK]
      REAL AJAC ( 0:NX+1 , 0:NZ+1 ) !"䥳ӥ
      REAL ALAP ( 0:NX+1 , 0:NZ+1 ) !"ץ饷
*
      LOGICAL OFIRST
      DATA    OFIRST  / .TRUE. /
*    
      SAVE  OFIRST 
*
      IF( OFIRST ) THEN
         OFIRST = .FALSE.
         CALL MSGDMP('M','DLPFRG',
     &               'LEAPFROG SCHEME TIME INTEGRATE : 98/06/11' )
         CALL MSGDMP('M','DLPFRG',
     &               '***** INFINITE PRNDTL NUMBER APPROX. *****' )
      ENDIF
*
*"        < 1. ΰβ٤η׻ >
*
      CALL DLPFT
     O      ( T3    , 
     I        PSI2  , T2    , 
     I        T1    , 
     C        QINT  , 
     C        DX    , DZ    , DT  ,
     W        AJAC  , ALAP    )
*
*"        < 2. ΰα٤η׻ >
*
      CALL DTMP2Z               !"  ٤鱲٤η׻(P inf )
     O       ( ZETA3 , 
     I         T3    , 
     C         RAYL  , 
     C         DX    , DZ    , DT  ,
     W         ALAP   )
*
*"        < 3. ŬѤήؿη׻ >
*
      CALL DBNDR
     O       ( PSI3  , 
     M         ZETA3 , T3   ,
     I         DX    , DZ    )
*
      RETURN
      END
*****************************************************************
      SUBROUTINE DLPFT     !" Leapfrog Scheme ˤ벹
     O             ( T3    , 
     I               PSI2  , T2    , 
     I               T1    , 
     C               QINT  , 
     C               DX    , DZ    , DT  ,
     W               AJAC2 , ALAP1   )
*
* [PARAM]
#include        "zcdim.F"            !" ʻ, ȿ
*
* [OUTPUT]
      REAL T3 ( 0:NX+1 , 0:NZ+1 )    !" (STEP)
*
* [INPUT]
      REAL PSI2  ( 0:NX+1 , 0:NZ+1 ) !" ήؿ(1STEP)
      REAL T2    ( 0:NX+1 , 0:NZ+1 ) !" (1STEP)
      REAL T1    ( 0:NX+1 , 0:NZ+1 ) !" (2STEP)
*
      REAL QINT                      !" ǮΨ
*
      REAL DX                        !" X γʻֳ
      REAL DZ                        !" Z γʻֳ
      REAL DT                        !" ֳִ
*
* [WORK]
      REAL AJAC2 ( 0:NX+1 , 0:NZ+1 ) !" 䥳ӥ
      REAL ALAP1 ( 0:NX+1 , 0:NZ+1 ) !" ץ饷
*
*  [INTERNAL WORK]
      INTEGER IX                   !" 롼ץ
      INTEGER IZ                   !" 롼ץ
*
*"        < 1. 䥳ӥη׻ >
*
      CALL DARJAC
     O       ( AJAC2,
     I         PSI2 , T2  ,
     C         DX   , DZ   )
*
*"        < 2. ץ饷η׻ >
*
      CALL DLAPLA
     O       ( ALAP1,
     I         T1   ,
     C         DX   , DZ   )
*
*"        < 3. ƥåɤβ٤ͤη׻ >
*
      DO 3010 IZ = 0 , NZ+1
         DO 3020 IX = 1 , NX
              T3(IX,IZ) 
     &    =   T1(IX,IZ)
     &      + 2.0D0*DT
     &        *( AJAC2(IX,IZ) + ALAP1(IX,IZ) + QINT )
 3020    CONTINUE
 3010 CONTINUE
*
      RETURN
      END
